from workspaces.capability.services.capability_info import CapabilityInfo

pytest_plugins = ["testing.utils.conftest"]


def test_edit_capability(mock_capability_info: CapabilityInfo):
    """
    Tests that edit_capability method properly follows its logic
    """
    mock_capability_info.session.update.return_value = 1
    assert mock_capability_info.edit_capability("null", "test", 2)
    assert mock_capability_info.session.flush.call_count == 2
    assert mock_capability_info.edit_capability("null", steps="test")
    assert mock_capability_info.session.flush.call_count == 3
    assert mock_capability_info.edit_capability("null", max_jobs=2)
    assert mock_capability_info.session.flush.call_count == 4
    assert mock_capability_info.edit_capability("null")
    assert mock_capability_info.session.flush.call_count == 4
    mock_capability_info.session.update.return_value = 0
    assert not mock_capability_info.edit_capability("null", "test", 2)
    assert mock_capability_info.session.flush.call_count == 4
