import inspect
from abc import ABC, abstractmethod

from workspaces.products.schema import ProductLocator
from workspaces.products.schema_interfaces import ProductIF


class EstimationServiceIF(ABC):
    """
    Service that estimates how long a capability will take to complete
    """

    pass


class MetricsServiceIF(ABC):
    """
    Service that records metrics
    """

    pass


class ArchiveServiceIF(ABC):
    """
    Abstracts services that are needed from the archive system.
    """

    @abstractmethod
    def lookup_product(self, locator: ProductLocator) -> ProductIF:
        """
        Look up a science product by its locator
        :param locator:  science product locator for this product
        :return:         science product
        """
        raise NotImplementedError(f"{self.__class__.__name__}.{inspect.stack()[0][3]}")


class NotificationInfoIF(ABC):
    """
    Parent class for all science products
    """

    pass
